//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <deque>
#include <algorithm>

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

void print (int elem)
{
  cout << elem << ' ';
}

int main(int argc, char* argv[])
{
  deque<int> coll;

  //    1  9 
  for (int i=1; i<=9; ++i) {
    coll.push_back(i); 
  }

  //      2 
  deque<int>::iterator pos1;
  pos1 = find (coll.begin(), coll.end(),  // 
               2); // 

  //      7 
  deque<int>::iterator pos2;
  pos2 = find (coll.begin(),coll.end(),  // 
               7); // 

  //      [pos1,pos2)
  cout << ToRus("     [pos1,pos2):\n");
  for_each (pos1, pos2, // 
            print);     // 
  cout << endl;

  //      
  deque<int>::reverse_iterator rpos1(pos1); 
  deque<int>::reverse_iterator rpos2(pos2);

  //     [pos1,pos2)   
  cout << ToRus("    [pos1,pos2)   :\n");
  for_each (rpos2, rpos1,    // 
            print);          // 
  cout << endl;

  getch();
  return 0;
}

//---------------------------------------------------------------------------